/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for Acl.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Acl extends com.google.api.client.json.GenericJson {

  /**
   * ETag of the collection.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * List of rules on the access control list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<AclRule> items;

  /**
   * Type of the collection ("calendar#acl").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * ETag of the collection.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * ETag of the collection.
   * @param etag etag or {@code null} for none
   */
  public Acl setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * List of rules on the access control list.
   * @return value or {@code null} for none
   */
  public java.util.List<AclRule> getItems() {
    return items;
  }

  /**
   * List of rules on the access control list.
   * @param items items or {@code null} for none
   */
  public Acl setItems(java.util.List<AclRule> items) {
    this.items = items;
    return this;
  }

  /**
   * Type of the collection ("calendar#acl").
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Type of the collection ("calendar#acl").
   * @param kind kind or {@code null} for none
   */
  public Acl setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token used to access the next page of this result. Omitted if no further results are available.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public Acl setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public Acl set(String fieldName, Object value) {
    return (Acl) super.set(fieldName, value);
  }

  @Override
  public Acl clone() {
    return (Acl) super.clone();
  }

}
