/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for CalendarListEntry.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CalendarListEntry extends com.google.api.client.json.GenericJson {

  /**
   * The effective access role that the authenticated user has on the calendar. Read-only. Possible
   * values are: - "freeBusyReader" - Provides read access to free/busy information.  - "reader" -
   * Provides read access to the calendar. Private events will appear to users with reader access,
   * but event details will be hidden.  - "writer" - Provides read and write access to the calendar.
   * Private events will appear to users with writer access, and event details will be visible.  -
   * "owner" - Provides ownership of the calendar. This role has all of the permissions of the
   * writer role with the additional ability to see and manipulate ACLs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String accessRole;

  /**
   * The main color of the calendar in the format '#0088aa'. This property supersedes the index-
   * based colorId property. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String backgroundColor;

  /**
   * The color of the calendar. This is an ID referring to an entry in the "calendar" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String colorId;

  /**
   * The default reminders that the authenticated user has for this calendar.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<EventReminder> defaultReminders;

  /**
   * Description of the calendar. Optional. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * ETag of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The foreground color of the calendar in the format '#ffffff'. This property supersedes the
   * index-based colorId property. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String foregroundColor;

  /**
   * Whether the calendar has been hidden from the list. Optional. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean hidden;

  /**
   * Identifier of the calendar.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Type of the resource ("calendar#calendarListEntry").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Geographic location of the calendar as free-form text. Optional. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String location;

  /**
   * Whether the calendar is the primary calendar of the authenticated user. Read-only. Optional.
   * The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean primary;

  /**
   * Whether the calendar content shows up in the calendar UI. Optional. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean selected;

  /**
   * Title of the calendar. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String summary;

  /**
   * The summary that the authenticated user has set for this calendar. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String summaryOverride;

  /**
   * The time zone of the calendar. Optional. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String timeZone;

  /**
   * The effective access role that the authenticated user has on the calendar. Read-only. Possible
   * values are: - "freeBusyReader" - Provides read access to free/busy information.  - "reader" -
   * Provides read access to the calendar. Private events will appear to users with reader access,
   * but event details will be hidden.  - "writer" - Provides read and write access to the calendar.
   * Private events will appear to users with writer access, and event details will be visible.  -
   * "owner" - Provides ownership of the calendar. This role has all of the permissions of the
   * writer role with the additional ability to see and manipulate ACLs.
   * @return value or {@code null} for none
   */
  public java.lang.String getAccessRole() {
    return accessRole;
  }

  /**
   * The effective access role that the authenticated user has on the calendar. Read-only. Possible
   * values are: - "freeBusyReader" - Provides read access to free/busy information.  - "reader" -
   * Provides read access to the calendar. Private events will appear to users with reader access,
   * but event details will be hidden.  - "writer" - Provides read and write access to the calendar.
   * Private events will appear to users with writer access, and event details will be visible.  -
   * "owner" - Provides ownership of the calendar. This role has all of the permissions of the
   * writer role with the additional ability to see and manipulate ACLs.
   * @param accessRole accessRole or {@code null} for none
   */
  public CalendarListEntry setAccessRole(java.lang.String accessRole) {
    this.accessRole = accessRole;
    return this;
  }

  /**
   * The main color of the calendar in the format '#0088aa'. This property supersedes the index-
   * based colorId property. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getBackgroundColor() {
    return backgroundColor;
  }

  /**
   * The main color of the calendar in the format '#0088aa'. This property supersedes the index-
   * based colorId property. Optional.
   * @param backgroundColor backgroundColor or {@code null} for none
   */
  public CalendarListEntry setBackgroundColor(java.lang.String backgroundColor) {
    this.backgroundColor = backgroundColor;
    return this;
  }

  /**
   * The color of the calendar. This is an ID referring to an entry in the "calendar" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getColorId() {
    return colorId;
  }

  /**
   * The color of the calendar. This is an ID referring to an entry in the "calendar" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * @param colorId colorId or {@code null} for none
   */
  public CalendarListEntry setColorId(java.lang.String colorId) {
    this.colorId = colorId;
    return this;
  }

  /**
   * The default reminders that the authenticated user has for this calendar.
   * @return value or {@code null} for none
   */
  public java.util.List<EventReminder> getDefaultReminders() {
    return defaultReminders;
  }

  /**
   * The default reminders that the authenticated user has for this calendar.
   * @param defaultReminders defaultReminders or {@code null} for none
   */
  public CalendarListEntry setDefaultReminders(java.util.List<EventReminder> defaultReminders) {
    this.defaultReminders = defaultReminders;
    return this;
  }

  /**
   * Description of the calendar. Optional. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of the calendar. Optional. Read-only.
   * @param description description or {@code null} for none
   */
  public CalendarListEntry setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * ETag of the resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * ETag of the resource.
   * @param etag etag or {@code null} for none
   */
  public CalendarListEntry setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The foreground color of the calendar in the format '#ffffff'. This property supersedes the
   * index-based colorId property. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getForegroundColor() {
    return foregroundColor;
  }

  /**
   * The foreground color of the calendar in the format '#ffffff'. This property supersedes the
   * index-based colorId property. Optional.
   * @param foregroundColor foregroundColor or {@code null} for none
   */
  public CalendarListEntry setForegroundColor(java.lang.String foregroundColor) {
    this.foregroundColor = foregroundColor;
    return this;
  }

  /**
   * Whether the calendar has been hidden from the list. Optional. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getHidden() {
    return hidden;
  }

  /**
   * Whether the calendar has been hidden from the list. Optional. The default is False.
   * @param hidden hidden or {@code null} for none
   */
  public CalendarListEntry setHidden(java.lang.Boolean hidden) {
    this.hidden = hidden;
    return this;
  }

  /**
   * Identifier of the calendar.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Identifier of the calendar.
   * @param id id or {@code null} for none
   */
  public CalendarListEntry setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Type of the resource ("calendar#calendarListEntry").
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Type of the resource ("calendar#calendarListEntry").
   * @param kind kind or {@code null} for none
   */
  public CalendarListEntry setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Geographic location of the calendar as free-form text. Optional. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getLocation() {
    return location;
  }

  /**
   * Geographic location of the calendar as free-form text. Optional. Read-only.
   * @param location location or {@code null} for none
   */
  public CalendarListEntry setLocation(java.lang.String location) {
    this.location = location;
    return this;
  }

  /**
   * Whether the calendar is the primary calendar of the authenticated user. Read-only. Optional.
   * The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getPrimary() {
    return primary;
  }

  /**
   * Whether the calendar is the primary calendar of the authenticated user. Read-only. Optional.
   * The default is False.
   * @param primary primary or {@code null} for none
   */
  public CalendarListEntry setPrimary(java.lang.Boolean primary) {
    this.primary = primary;
    return this;
  }

  /**
   * Whether the calendar content shows up in the calendar UI. Optional. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getSelected() {
    return selected;
  }

  /**
   * Whether the calendar content shows up in the calendar UI. Optional. The default is False.
   * @param selected selected or {@code null} for none
   */
  public CalendarListEntry setSelected(java.lang.Boolean selected) {
    this.selected = selected;
    return this;
  }

  /**
   * Title of the calendar. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getSummary() {
    return summary;
  }

  /**
   * Title of the calendar. Read-only.
   * @param summary summary or {@code null} for none
   */
  public CalendarListEntry setSummary(java.lang.String summary) {
    this.summary = summary;
    return this;
  }

  /**
   * The summary that the authenticated user has set for this calendar. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getSummaryOverride() {
    return summaryOverride;
  }

  /**
   * The summary that the authenticated user has set for this calendar. Optional.
   * @param summaryOverride summaryOverride or {@code null} for none
   */
  public CalendarListEntry setSummaryOverride(java.lang.String summaryOverride) {
    this.summaryOverride = summaryOverride;
    return this;
  }

  /**
   * The time zone of the calendar. Optional. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getTimeZone() {
    return timeZone;
  }

  /**
   * The time zone of the calendar. Optional. Read-only.
   * @param timeZone timeZone or {@code null} for none
   */
  public CalendarListEntry setTimeZone(java.lang.String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

  @Override
  public CalendarListEntry set(String fieldName, Object value) {
    return (CalendarListEntry) super.set(fieldName, value);
  }

  @Override
  public CalendarListEntry clone() {
    return (CalendarListEntry) super.clone();
  }

}
