/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for Event.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Event extends com.google.api.client.json.GenericJson {

  /**
   * Whether anyone can invite themselves to the event. Optional. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean anyoneCanAddSelf;

  /**
   * The attendees of the event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<EventAttendee> attendees;

  static {
    // hack to force ProGuard to consider EventAttendee used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(EventAttendee.class);
  }

  /**
   * Whether attendees may have been omitted from the event's representation. When retrieving an
   * event, this may be due to a restriction specified by the 'maxAttendee' query parameter. When
   * updating an event, this can be used to only update the participant's response. Optional. The
   * default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean attendeesOmitted;

  /**
   * The color of the event. This is an ID referring to an entry in the "event" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String colorId;

  /**
   * Creation time of the event (as a RFC 3339 timestamp). Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime created;

  /**
   * The creator of the event. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Creator creator;

  /**
   * Description of the event. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * The (exclusive) end time of the event. For a recurring event, this is the end time of the first
   * instance.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventDateTime end;

  /**
   * Whether the end time is actually unspecified. An end time is still provided for compatibility
   * reasons, even if this attribute is set to True. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean endTimeUnspecified;

  /**
   * ETag of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * Extended properties of the event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ExtendedProperties extendedProperties;

  /**
   * A gadget that extends this event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Gadget gadget;

  /**
   * Whether attendees other than the organizer can invite others to the event. Optional. The
   * default is True.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean guestsCanInviteOthers;

  /**
   * Whether attendees other than the organizer can modify the event. Optional. The default is
   * False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean guestsCanModify;

  /**
   * Whether attendees other than the organizer can see who the event's attendees are. Optional. The
   * default is True.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean guestsCanSeeOtherGuests;

  /**
   * An absolute link to the Google+ hangout associated with this event. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String hangoutLink;

  /**
   * An absolute link to this event in the Google Calendar Web UI. Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String htmlLink;

  /**
   * Event ID in the iCalendar format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String iCalUID;

  /**
   * Identifier of the event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Type of the resource ("calendar#event").
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Geographic location of the event as free-form text. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String location;

  /**
   * Whether this is a locked event copy where no changes can be made to the main event fields
   * "summary", "description", "location", "start", "end" or "recurrence". The default is False.
   * Read-Only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean locked;

  /**
   * The organizer of the event. If the organizer is also an attendee, this is indicated with a
   * separate entry in 'attendees' with the 'organizer' field set to True. To change the organizer,
   * use the "move" operation. Read-only, except when importing an event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Organizer organizer;

  /**
   * For an instance of a recurring event, this is the time at which this event would start
   * according to the recurrence data in the recurring event identified by recurringEventId.
   * Immutable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventDateTime originalStartTime;

  /**
   * Whether this is a private event copy where changes are not shared with other copies on other
   * calendars. Optional. Immutable. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean privateCopy;

  /**
   * List of RRULE, EXRULE, RDATE and EXDATE lines for a recurring event. This field is omitted for
   * single events or instances of recurring events.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> recurrence;

  /**
   * For an instance of a recurring event, this is the event ID of the recurring event itself.
   * Immutable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String recurringEventId;

  /**
   * Information about the event's reminders for the authenticated user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Reminders reminders;

  /**
   * Sequence number as per iCalendar.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer sequence;

  /**
   * Source of an event from which it was created; for example a web page, an email message or any
   * document identifiable by an URL using HTTP/HTTPS protocol. Accessible only by the creator of
   * the event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Source source;

  /**
   * The (inclusive) start time of the event. For a recurring event, this is the start time of the
   * first instance.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventDateTime start;

  /**
   * Status of the event. Optional. Possible values are: - "confirmed" - The event is confirmed.
   * This is the default status.  - "tentative" - The event is tentatively confirmed.  - "cancelled"
   * - The event is cancelled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Title of the event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String summary;

  /**
   * Whether the event blocks time on the calendar. Optional. Possible values are: - "opaque" - The
   * event blocks time on the calendar. This is the default value.  - "transparent" - The event does
   * not block time on the calendar.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String transparency;

  /**
   * Last modification time of the event (as a RFC 3339 timestamp). Read-only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime updated;

  /**
   * Visibility of the event. Optional. Possible values are: - "default" - Uses the default
   * visibility for events on the calendar. This is the default value.  - "public" - The event is
   * public and event details are visible to all readers of the calendar.  - "private" - The event
   * is private and only event attendees may view event details.  - "confidential" - The event is
   * private. This value is provided for compatibility reasons.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String visibility;

  /**
   * Whether anyone can invite themselves to the event. Optional. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAnyoneCanAddSelf() {
    return anyoneCanAddSelf;
  }

  /**
   * Whether anyone can invite themselves to the event. Optional. The default is False.
   * @param anyoneCanAddSelf anyoneCanAddSelf or {@code null} for none
   */
  public Event setAnyoneCanAddSelf(java.lang.Boolean anyoneCanAddSelf) {
    this.anyoneCanAddSelf = anyoneCanAddSelf;
    return this;
  }

  /**
   * The attendees of the event.
   * @return value or {@code null} for none
   */
  public java.util.List<EventAttendee> getAttendees() {
    return attendees;
  }

  /**
   * The attendees of the event.
   * @param attendees attendees or {@code null} for none
   */
  public Event setAttendees(java.util.List<EventAttendee> attendees) {
    this.attendees = attendees;
    return this;
  }

  /**
   * Whether attendees may have been omitted from the event's representation. When retrieving an
   * event, this may be due to a restriction specified by the 'maxAttendee' query parameter. When
   * updating an event, this can be used to only update the participant's response. Optional. The
   * default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAttendeesOmitted() {
    return attendeesOmitted;
  }

  /**
   * Whether attendees may have been omitted from the event's representation. When retrieving an
   * event, this may be due to a restriction specified by the 'maxAttendee' query parameter. When
   * updating an event, this can be used to only update the participant's response. Optional. The
   * default is False.
   * @param attendeesOmitted attendeesOmitted or {@code null} for none
   */
  public Event setAttendeesOmitted(java.lang.Boolean attendeesOmitted) {
    this.attendeesOmitted = attendeesOmitted;
    return this;
  }

  /**
   * The color of the event. This is an ID referring to an entry in the "event" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getColorId() {
    return colorId;
  }

  /**
   * The color of the event. This is an ID referring to an entry in the "event" section of the
   * colors definition (see the "colors" endpoint). Optional.
   * @param colorId colorId or {@code null} for none
   */
  public Event setColorId(java.lang.String colorId) {
    this.colorId = colorId;
    return this;
  }

  /**
   * Creation time of the event (as a RFC 3339 timestamp). Read-only.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreated() {
    return created;
  }

  /**
   * Creation time of the event (as a RFC 3339 timestamp). Read-only.
   * @param created created or {@code null} for none
   */
  public Event setCreated(com.google.api.client.util.DateTime created) {
    this.created = created;
    return this;
  }

  /**
   * The creator of the event. Read-only.
   * @return value or {@code null} for none
   */
  public Creator getCreator() {
    return creator;
  }

  /**
   * The creator of the event. Read-only.
   * @param creator creator or {@code null} for none
   */
  public Event setCreator(Creator creator) {
    this.creator = creator;
    return this;
  }

  /**
   * Description of the event. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of the event. Optional.
   * @param description description or {@code null} for none
   */
  public Event setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * The (exclusive) end time of the event. For a recurring event, this is the end time of the first
   * instance.
   * @return value or {@code null} for none
   */
  public EventDateTime getEnd() {
    return end;
  }

  /**
   * The (exclusive) end time of the event. For a recurring event, this is the end time of the first
   * instance.
   * @param end end or {@code null} for none
   */
  public Event setEnd(EventDateTime end) {
    this.end = end;
    return this;
  }

  /**
   * Whether the end time is actually unspecified. An end time is still provided for compatibility
   * reasons, even if this attribute is set to True. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEndTimeUnspecified() {
    return endTimeUnspecified;
  }

  /**
   * Whether the end time is actually unspecified. An end time is still provided for compatibility
   * reasons, even if this attribute is set to True. The default is False.
   * @param endTimeUnspecified endTimeUnspecified or {@code null} for none
   */
  public Event setEndTimeUnspecified(java.lang.Boolean endTimeUnspecified) {
    this.endTimeUnspecified = endTimeUnspecified;
    return this;
  }

  /**
   * ETag of the resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * ETag of the resource.
   * @param etag etag or {@code null} for none
   */
  public Event setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * Extended properties of the event.
   * @return value or {@code null} for none
   */
  public ExtendedProperties getExtendedProperties() {
    return extendedProperties;
  }

  /**
   * Extended properties of the event.
   * @param extendedProperties extendedProperties or {@code null} for none
   */
  public Event setExtendedProperties(ExtendedProperties extendedProperties) {
    this.extendedProperties = extendedProperties;
    return this;
  }

  /**
   * A gadget that extends this event.
   * @return value or {@code null} for none
   */
  public Gadget getGadget() {
    return gadget;
  }

  /**
   * A gadget that extends this event.
   * @param gadget gadget or {@code null} for none
   */
  public Event setGadget(Gadget gadget) {
    this.gadget = gadget;
    return this;
  }

  /**
   * Whether attendees other than the organizer can invite others to the event. Optional. The
   * default is True.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getGuestsCanInviteOthers() {
    return guestsCanInviteOthers;
  }

  /**
   * Whether attendees other than the organizer can invite others to the event. Optional. The
   * default is True.
   * @param guestsCanInviteOthers guestsCanInviteOthers or {@code null} for none
   */
  public Event setGuestsCanInviteOthers(java.lang.Boolean guestsCanInviteOthers) {
    this.guestsCanInviteOthers = guestsCanInviteOthers;
    return this;
  }

  /**
   * Whether attendees other than the organizer can modify the event. Optional. The default is
   * False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getGuestsCanModify() {
    return guestsCanModify;
  }

  /**
   * Whether attendees other than the organizer can modify the event. Optional. The default is
   * False.
   * @param guestsCanModify guestsCanModify or {@code null} for none
   */
  public Event setGuestsCanModify(java.lang.Boolean guestsCanModify) {
    this.guestsCanModify = guestsCanModify;
    return this;
  }

  /**
   * Whether attendees other than the organizer can see who the event's attendees are. Optional. The
   * default is True.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getGuestsCanSeeOtherGuests() {
    return guestsCanSeeOtherGuests;
  }

  /**
   * Whether attendees other than the organizer can see who the event's attendees are. Optional. The
   * default is True.
   * @param guestsCanSeeOtherGuests guestsCanSeeOtherGuests or {@code null} for none
   */
  public Event setGuestsCanSeeOtherGuests(java.lang.Boolean guestsCanSeeOtherGuests) {
    this.guestsCanSeeOtherGuests = guestsCanSeeOtherGuests;
    return this;
  }

  /**
   * An absolute link to the Google+ hangout associated with this event. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getHangoutLink() {
    return hangoutLink;
  }

  /**
   * An absolute link to the Google+ hangout associated with this event. Read-only.
   * @param hangoutLink hangoutLink or {@code null} for none
   */
  public Event setHangoutLink(java.lang.String hangoutLink) {
    this.hangoutLink = hangoutLink;
    return this;
  }

  /**
   * An absolute link to this event in the Google Calendar Web UI. Read-only.
   * @return value or {@code null} for none
   */
  public java.lang.String getHtmlLink() {
    return htmlLink;
  }

  /**
   * An absolute link to this event in the Google Calendar Web UI. Read-only.
   * @param htmlLink htmlLink or {@code null} for none
   */
  public Event setHtmlLink(java.lang.String htmlLink) {
    this.htmlLink = htmlLink;
    return this;
  }

  /**
   * Event ID in the iCalendar format.
   * @return value or {@code null} for none
   */
  public java.lang.String getICalUID() {
    return iCalUID;
  }

  /**
   * Event ID in the iCalendar format.
   * @param iCalUID iCalUID or {@code null} for none
   */
  public Event setICalUID(java.lang.String iCalUID) {
    this.iCalUID = iCalUID;
    return this;
  }

  /**
   * Identifier of the event.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Identifier of the event.
   * @param id id or {@code null} for none
   */
  public Event setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Type of the resource ("calendar#event").
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Type of the resource ("calendar#event").
   * @param kind kind or {@code null} for none
   */
  public Event setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Geographic location of the event as free-form text. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getLocation() {
    return location;
  }

  /**
   * Geographic location of the event as free-form text. Optional.
   * @param location location or {@code null} for none
   */
  public Event setLocation(java.lang.String location) {
    this.location = location;
    return this;
  }

  /**
   * Whether this is a locked event copy where no changes can be made to the main event fields
   * "summary", "description", "location", "start", "end" or "recurrence". The default is False.
   * Read-Only.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getLocked() {
    return locked;
  }

  /**
   * Whether this is a locked event copy where no changes can be made to the main event fields
   * "summary", "description", "location", "start", "end" or "recurrence". The default is False.
   * Read-Only.
   * @param locked locked or {@code null} for none
   */
  public Event setLocked(java.lang.Boolean locked) {
    this.locked = locked;
    return this;
  }

  /**
   * The organizer of the event. If the organizer is also an attendee, this is indicated with a
   * separate entry in 'attendees' with the 'organizer' field set to True. To change the organizer,
   * use the "move" operation. Read-only, except when importing an event.
   * @return value or {@code null} for none
   */
  public Organizer getOrganizer() {
    return organizer;
  }

  /**
   * The organizer of the event. If the organizer is also an attendee, this is indicated with a
   * separate entry in 'attendees' with the 'organizer' field set to True. To change the organizer,
   * use the "move" operation. Read-only, except when importing an event.
   * @param organizer organizer or {@code null} for none
   */
  public Event setOrganizer(Organizer organizer) {
    this.organizer = organizer;
    return this;
  }

  /**
   * For an instance of a recurring event, this is the time at which this event would start
   * according to the recurrence data in the recurring event identified by recurringEventId.
   * Immutable.
   * @return value or {@code null} for none
   */
  public EventDateTime getOriginalStartTime() {
    return originalStartTime;
  }

  /**
   * For an instance of a recurring event, this is the time at which this event would start
   * according to the recurrence data in the recurring event identified by recurringEventId.
   * Immutable.
   * @param originalStartTime originalStartTime or {@code null} for none
   */
  public Event setOriginalStartTime(EventDateTime originalStartTime) {
    this.originalStartTime = originalStartTime;
    return this;
  }

  /**
   * Whether this is a private event copy where changes are not shared with other copies on other
   * calendars. Optional. Immutable. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getPrivateCopy() {
    return privateCopy;
  }

  /**
   * Whether this is a private event copy where changes are not shared with other copies on other
   * calendars. Optional. Immutable. The default is False.
   * @param privateCopy privateCopy or {@code null} for none
   */
  public Event setPrivateCopy(java.lang.Boolean privateCopy) {
    this.privateCopy = privateCopy;
    return this;
  }

  /**
   * List of RRULE, EXRULE, RDATE and EXDATE lines for a recurring event. This field is omitted for
   * single events or instances of recurring events.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRecurrence() {
    return recurrence;
  }

  /**
   * List of RRULE, EXRULE, RDATE and EXDATE lines for a recurring event. This field is omitted for
   * single events or instances of recurring events.
   * @param recurrence recurrence or {@code null} for none
   */
  public Event setRecurrence(java.util.List<java.lang.String> recurrence) {
    this.recurrence = recurrence;
    return this;
  }

  /**
   * For an instance of a recurring event, this is the event ID of the recurring event itself.
   * Immutable.
   * @return value or {@code null} for none
   */
  public java.lang.String getRecurringEventId() {
    return recurringEventId;
  }

  /**
   * For an instance of a recurring event, this is the event ID of the recurring event itself.
   * Immutable.
   * @param recurringEventId recurringEventId or {@code null} for none
   */
  public Event setRecurringEventId(java.lang.String recurringEventId) {
    this.recurringEventId = recurringEventId;
    return this;
  }

  /**
   * Information about the event's reminders for the authenticated user.
   * @return value or {@code null} for none
   */
  public Reminders getReminders() {
    return reminders;
  }

  /**
   * Information about the event's reminders for the authenticated user.
   * @param reminders reminders or {@code null} for none
   */
  public Event setReminders(Reminders reminders) {
    this.reminders = reminders;
    return this;
  }

  /**
   * Sequence number as per iCalendar.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getSequence() {
    return sequence;
  }

  /**
   * Sequence number as per iCalendar.
   * @param sequence sequence or {@code null} for none
   */
  public Event setSequence(java.lang.Integer sequence) {
    this.sequence = sequence;
    return this;
  }

  /**
   * Source of an event from which it was created; for example a web page, an email message or any
   * document identifiable by an URL using HTTP/HTTPS protocol. Accessible only by the creator of
   * the event.
   * @return value or {@code null} for none
   */
  public Source getSource() {
    return source;
  }

  /**
   * Source of an event from which it was created; for example a web page, an email message or any
   * document identifiable by an URL using HTTP/HTTPS protocol. Accessible only by the creator of
   * the event.
   * @param source source or {@code null} for none
   */
  public Event setSource(Source source) {
    this.source = source;
    return this;
  }

  /**
   * The (inclusive) start time of the event. For a recurring event, this is the start time of the
   * first instance.
   * @return value or {@code null} for none
   */
  public EventDateTime getStart() {
    return start;
  }

  /**
   * The (inclusive) start time of the event. For a recurring event, this is the start time of the
   * first instance.
   * @param start start or {@code null} for none
   */
  public Event setStart(EventDateTime start) {
    this.start = start;
    return this;
  }

  /**
   * Status of the event. Optional. Possible values are: - "confirmed" - The event is confirmed.
   * This is the default status.  - "tentative" - The event is tentatively confirmed.  - "cancelled"
   * - The event is cancelled.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of the event. Optional. Possible values are: - "confirmed" - The event is confirmed.
   * This is the default status.  - "tentative" - The event is tentatively confirmed.  - "cancelled"
   * - The event is cancelled.
   * @param status status or {@code null} for none
   */
  public Event setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * Title of the event.
   * @return value or {@code null} for none
   */
  public java.lang.String getSummary() {
    return summary;
  }

  /**
   * Title of the event.
   * @param summary summary or {@code null} for none
   */
  public Event setSummary(java.lang.String summary) {
    this.summary = summary;
    return this;
  }

  /**
   * Whether the event blocks time on the calendar. Optional. Possible values are: - "opaque" - The
   * event blocks time on the calendar. This is the default value.  - "transparent" - The event does
   * not block time on the calendar.
   * @return value or {@code null} for none
   */
  public java.lang.String getTransparency() {
    return transparency;
  }

  /**
   * Whether the event blocks time on the calendar. Optional. Possible values are: - "opaque" - The
   * event blocks time on the calendar. This is the default value.  - "transparent" - The event does
   * not block time on the calendar.
   * @param transparency transparency or {@code null} for none
   */
  public Event setTransparency(java.lang.String transparency) {
    this.transparency = transparency;
    return this;
  }

  /**
   * Last modification time of the event (as a RFC 3339 timestamp). Read-only.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getUpdated() {
    return updated;
  }

  /**
   * Last modification time of the event (as a RFC 3339 timestamp). Read-only.
   * @param updated updated or {@code null} for none
   */
  public Event setUpdated(com.google.api.client.util.DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * Visibility of the event. Optional. Possible values are: - "default" - Uses the default
   * visibility for events on the calendar. This is the default value.  - "public" - The event is
   * public and event details are visible to all readers of the calendar.  - "private" - The event
   * is private and only event attendees may view event details.  - "confidential" - The event is
   * private. This value is provided for compatibility reasons.
   * @return value or {@code null} for none
   */
  public java.lang.String getVisibility() {
    return visibility;
  }

  /**
   * Visibility of the event. Optional. Possible values are: - "default" - Uses the default
   * visibility for events on the calendar. This is the default value.  - "public" - The event is
   * public and event details are visible to all readers of the calendar.  - "private" - The event
   * is private and only event attendees may view event details.  - "confidential" - The event is
   * private. This value is provided for compatibility reasons.
   * @param visibility visibility or {@code null} for none
   */
  public Event setVisibility(java.lang.String visibility) {
    this.visibility = visibility;
    return this;
  }

  @Override
  public Event set(String fieldName, Object value) {
    return (Event) super.set(fieldName, value);
  }

  @Override
  public Event clone() {
    return (Event) super.clone();
  }

  /**
   * The creator of the event. Read-only.
   */
  public static final class Creator extends com.google.api.client.json.GenericJson {

    /**
     * The creator's name, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * The creator's email address, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String email;

    /**
     * The creator's Profile ID, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String id;

    /**
     * Whether the creator corresponds to the calendar on which this copy of the event appears. Read-
     * only. The default is False.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean self;

    /**
     * The creator's name, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * The creator's name, if available.
     * @param displayName displayName or {@code null} for none
     */
    public Creator setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * The creator's email address, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getEmail() {
      return email;
    }

    /**
     * The creator's email address, if available.
     * @param email email or {@code null} for none
     */
    public Creator setEmail(java.lang.String email) {
      this.email = email;
      return this;
    }

    /**
     * The creator's Profile ID, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getId() {
      return id;
    }

    /**
     * The creator's Profile ID, if available.
     * @param id id or {@code null} for none
     */
    public Creator setId(java.lang.String id) {
      this.id = id;
      return this;
    }

    /**
     * Whether the creator corresponds to the calendar on which this copy of the event appears. Read-
     * only. The default is False.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getSelf() {
      return self;
    }

    /**
     * Whether the creator corresponds to the calendar on which this copy of the event appears. Read-
     * only. The default is False.
     * @param self self or {@code null} for none
     */
    public Creator setSelf(java.lang.Boolean self) {
      this.self = self;
      return this;
    }

    @Override
    public Creator set(String fieldName, Object value) {
      return (Creator) super.set(fieldName, value);
    }

    @Override
    public Creator clone() {
      return (Creator) super.clone();
    }

  }

  /**
   * Extended properties of the event.
   */
  public static final class ExtendedProperties extends com.google.api.client.json.GenericJson {

    /**
     * Properties that are private to the copy of the event that appears on this calendar.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key("private")
    private java.util.Map<String, java.lang.String> calendarPrivate;

    /**
     * Properties that are shared between copies of the event on other attendees' calendars.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.Map<String, java.lang.String> shared;

    /**
     * Properties that are private to the copy of the event that appears on this calendar.
     * @return value or {@code null} for none
     */
    public java.util.Map<String, java.lang.String> getPrivate() {
      return calendarPrivate;
    }

    /**
     * Properties that are private to the copy of the event that appears on this calendar.
     * @param calendarPrivate calendarPrivate or {@code null} for none
     */
    public ExtendedProperties setPrivate(java.util.Map<String, java.lang.String> calendarPrivate) {
      this.calendarPrivate = calendarPrivate;
      return this;
    }

    /**
     * Properties that are shared between copies of the event on other attendees' calendars.
     * @return value or {@code null} for none
     */
    public java.util.Map<String, java.lang.String> getShared() {
      return shared;
    }

    /**
     * Properties that are shared between copies of the event on other attendees' calendars.
     * @param shared shared or {@code null} for none
     */
    public ExtendedProperties setShared(java.util.Map<String, java.lang.String> shared) {
      this.shared = shared;
      return this;
    }

    @Override
    public ExtendedProperties set(String fieldName, Object value) {
      return (ExtendedProperties) super.set(fieldName, value);
    }

    @Override
    public ExtendedProperties clone() {
      return (ExtendedProperties) super.clone();
    }

  }

  /**
   * A gadget that extends this event.
   */
  public static final class Gadget extends com.google.api.client.json.GenericJson {

    /**
     * The gadget's display mode. Optional. Possible values are: - "icon" - The gadget displays next
     * to the event's title in the calendar view.  - "chip" - The gadget displays when the event is
     * clicked.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String display;

    /**
     * The gadget's height in pixels. Optional.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer height;

    /**
     * The gadget's icon URL.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String iconLink;

    /**
     * The gadget's URL.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String link;

    /**
     * Preferences.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.Map<String, java.lang.String> preferences;

    /**
     * The gadget's title.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String title;

    /**
     * The gadget's type.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * The gadget's width in pixels. Optional.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer width;

    /**
     * The gadget's display mode. Optional. Possible values are: - "icon" - The gadget displays next
     * to the event's title in the calendar view.  - "chip" - The gadget displays when the event is
     * clicked.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplay() {
      return display;
    }

    /**
     * The gadget's display mode. Optional. Possible values are: - "icon" - The gadget displays next
     * to the event's title in the calendar view.  - "chip" - The gadget displays when the event is
     * clicked.
     * @param display display or {@code null} for none
     */
    public Gadget setDisplay(java.lang.String display) {
      this.display = display;
      return this;
    }

    /**
     * The gadget's height in pixels. Optional.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getHeight() {
      return height;
    }

    /**
     * The gadget's height in pixels. Optional.
     * @param height height or {@code null} for none
     */
    public Gadget setHeight(java.lang.Integer height) {
      this.height = height;
      return this;
    }

    /**
     * The gadget's icon URL.
     * @return value or {@code null} for none
     */
    public java.lang.String getIconLink() {
      return iconLink;
    }

    /**
     * The gadget's icon URL.
     * @param iconLink iconLink or {@code null} for none
     */
    public Gadget setIconLink(java.lang.String iconLink) {
      this.iconLink = iconLink;
      return this;
    }

    /**
     * The gadget's URL.
     * @return value or {@code null} for none
     */
    public java.lang.String getLink() {
      return link;
    }

    /**
     * The gadget's URL.
     * @param link link or {@code null} for none
     */
    public Gadget setLink(java.lang.String link) {
      this.link = link;
      return this;
    }

    /**
     * Preferences.
     * @return value or {@code null} for none
     */
    public java.util.Map<String, java.lang.String> getPreferences() {
      return preferences;
    }

    /**
     * Preferences.
     * @param preferences preferences or {@code null} for none
     */
    public Gadget setPreferences(java.util.Map<String, java.lang.String> preferences) {
      this.preferences = preferences;
      return this;
    }

    /**
     * The gadget's title.
     * @return value or {@code null} for none
     */
    public java.lang.String getTitle() {
      return title;
    }

    /**
     * The gadget's title.
     * @param title title or {@code null} for none
     */
    public Gadget setTitle(java.lang.String title) {
      this.title = title;
      return this;
    }

    /**
     * The gadget's type.
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * The gadget's type.
     * @param type type or {@code null} for none
     */
    public Gadget setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    /**
     * The gadget's width in pixels. Optional.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getWidth() {
      return width;
    }

    /**
     * The gadget's width in pixels. Optional.
     * @param width width or {@code null} for none
     */
    public Gadget setWidth(java.lang.Integer width) {
      this.width = width;
      return this;
    }

    @Override
    public Gadget set(String fieldName, Object value) {
      return (Gadget) super.set(fieldName, value);
    }

    @Override
    public Gadget clone() {
      return (Gadget) super.clone();
    }

  }

  /**
   * The organizer of the event. If the organizer is also an attendee, this is indicated with a
   * separate entry in 'attendees' with the 'organizer' field set to True. To change the organizer,
   * use the "move" operation. Read-only, except when importing an event.
   */
  public static final class Organizer extends com.google.api.client.json.GenericJson {

    /**
     * The organizer's name, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * The organizer's email address, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String email;

    /**
     * The organizer's Profile ID, if available.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String id;

    /**
     * Whether the organizer corresponds to the calendar on which this copy of the event appears.
     * Read-only. The default is False.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean self;

    /**
     * The organizer's name, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * The organizer's name, if available.
     * @param displayName displayName or {@code null} for none
     */
    public Organizer setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * The organizer's email address, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getEmail() {
      return email;
    }

    /**
     * The organizer's email address, if available.
     * @param email email or {@code null} for none
     */
    public Organizer setEmail(java.lang.String email) {
      this.email = email;
      return this;
    }

    /**
     * The organizer's Profile ID, if available.
     * @return value or {@code null} for none
     */
    public java.lang.String getId() {
      return id;
    }

    /**
     * The organizer's Profile ID, if available.
     * @param id id or {@code null} for none
     */
    public Organizer setId(java.lang.String id) {
      this.id = id;
      return this;
    }

    /**
     * Whether the organizer corresponds to the calendar on which this copy of the event appears.
     * Read-only. The default is False.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getSelf() {
      return self;
    }

    /**
     * Whether the organizer corresponds to the calendar on which this copy of the event appears.
     * Read-only. The default is False.
     * @param self self or {@code null} for none
     */
    public Organizer setSelf(java.lang.Boolean self) {
      this.self = self;
      return this;
    }

    @Override
    public Organizer set(String fieldName, Object value) {
      return (Organizer) super.set(fieldName, value);
    }

    @Override
    public Organizer clone() {
      return (Organizer) super.clone();
    }

  }

  /**
   * Information about the event's reminders for the authenticated user.
   */
  public static final class Reminders extends com.google.api.client.json.GenericJson {

    /**
     * If the event doesn't use the default reminders, this lists the reminders specific to the event,
     * or, if not set, indicates that no reminders are set for this event.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<EventReminder> overrides;

    static {
      // hack to force ProGuard to consider EventReminder used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(EventReminder.class);
    }

    /**
     * Whether the default reminders of the calendar apply to the event.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean useDefault;

    /**
     * If the event doesn't use the default reminders, this lists the reminders specific to the event,
     * or, if not set, indicates that no reminders are set for this event.
     * @return value or {@code null} for none
     */
    public java.util.List<EventReminder> getOverrides() {
      return overrides;
    }

    /**
     * If the event doesn't use the default reminders, this lists the reminders specific to the event,
     * or, if not set, indicates that no reminders are set for this event.
     * @param overrides overrides or {@code null} for none
     */
    public Reminders setOverrides(java.util.List<EventReminder> overrides) {
      this.overrides = overrides;
      return this;
    }

    /**
     * Whether the default reminders of the calendar apply to the event.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getUseDefault() {
      return useDefault;
    }

    /**
     * Whether the default reminders of the calendar apply to the event.
     * @param useDefault useDefault or {@code null} for none
     */
    public Reminders setUseDefault(java.lang.Boolean useDefault) {
      this.useDefault = useDefault;
      return this;
    }

    @Override
    public Reminders set(String fieldName, Object value) {
      return (Reminders) super.set(fieldName, value);
    }

    @Override
    public Reminders clone() {
      return (Reminders) super.clone();
    }

  }

  /**
   * Source of an event from which it was created; for example a web page, an email message or any
   * document identifiable by an URL using HTTP/HTTPS protocol. Accessible only by the creator of the
   * event.
   */
  public static final class Source extends com.google.api.client.json.GenericJson {

    /**
     * Title of the source; for example a title of a web page or an email subject.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String title;

    /**
     * URL of the source pointing to a resource. URL's protocol must be HTTP or HTTPS.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * Title of the source; for example a title of a web page or an email subject.
     * @return value or {@code null} for none
     */
    public java.lang.String getTitle() {
      return title;
    }

    /**
     * Title of the source; for example a title of a web page or an email subject.
     * @param title title or {@code null} for none
     */
    public Source setTitle(java.lang.String title) {
      this.title = title;
      return this;
    }

    /**
     * URL of the source pointing to a resource. URL's protocol must be HTTP or HTTPS.
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * URL of the source pointing to a resource. URL's protocol must be HTTP or HTTPS.
     * @param url url or {@code null} for none
     */
    public Source setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Source set(String fieldName, Object value) {
      return (Source) super.set(fieldName, value);
    }

    @Override
    public Source clone() {
      return (Source) super.clone();
    }

  }

}
