/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for EventAttendee.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class EventAttendee extends com.google.api.client.json.GenericJson {

  /**
   * Number of additional guests. Optional. The default is 0.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer additionalGuests;

  /**
   * The attendee's response comment. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String comment;

  /**
   * The attendee's name, if available. Optional.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * The attendee's email address, if available. This field must be present when adding an attendee.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String email;

  /**
   * The attendee's Profile ID, if available.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Whether this is an optional attendee. Optional. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean optional;

  /**
   * Whether the attendee is the organizer of the event. Read-only. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean organizer;

  /**
   * Whether the attendee is a resource. Read-only. The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean resource;

  /**
   * The attendee's response status. Possible values are: - "needsAction" - The attendee has not
   * responded to the invitation.  - "declined" - The attendee has declined the invitation.  -
   * "tentative" - The attendee has tentatively accepted the invitation.  - "accepted" - The
   * attendee has accepted the invitation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String responseStatus;

  /**
   * Whether this entry represents the calendar on which this copy of the event appears. Read-only.
   * The default is False.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean self;

  /**
   * Number of additional guests. Optional. The default is 0.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getAdditionalGuests() {
    return additionalGuests;
  }

  /**
   * Number of additional guests. Optional. The default is 0.
   * @param additionalGuests additionalGuests or {@code null} for none
   */
  public EventAttendee setAdditionalGuests(java.lang.Integer additionalGuests) {
    this.additionalGuests = additionalGuests;
    return this;
  }

  /**
   * The attendee's response comment. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getComment() {
    return comment;
  }

  /**
   * The attendee's response comment. Optional.
   * @param comment comment or {@code null} for none
   */
  public EventAttendee setComment(java.lang.String comment) {
    this.comment = comment;
    return this;
  }

  /**
   * The attendee's name, if available. Optional.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * The attendee's name, if available. Optional.
   * @param displayName displayName or {@code null} for none
   */
  public EventAttendee setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * The attendee's email address, if available. This field must be present when adding an attendee.
   * @return value or {@code null} for none
   */
  public java.lang.String getEmail() {
    return email;
  }

  /**
   * The attendee's email address, if available. This field must be present when adding an attendee.
   * @param email email or {@code null} for none
   */
  public EventAttendee setEmail(java.lang.String email) {
    this.email = email;
    return this;
  }

  /**
   * The attendee's Profile ID, if available.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The attendee's Profile ID, if available.
   * @param id id or {@code null} for none
   */
  public EventAttendee setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Whether this is an optional attendee. Optional. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getOptional() {
    return optional;
  }

  /**
   * Whether this is an optional attendee. Optional. The default is False.
   * @param optional optional or {@code null} for none
   */
  public EventAttendee setOptional(java.lang.Boolean optional) {
    this.optional = optional;
    return this;
  }

  /**
   * Whether the attendee is the organizer of the event. Read-only. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getOrganizer() {
    return organizer;
  }

  /**
   * Whether the attendee is the organizer of the event. Read-only. The default is False.
   * @param organizer organizer or {@code null} for none
   */
  public EventAttendee setOrganizer(java.lang.Boolean organizer) {
    this.organizer = organizer;
    return this;
  }

  /**
   * Whether the attendee is a resource. Read-only. The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getResource() {
    return resource;
  }

  /**
   * Whether the attendee is a resource. Read-only. The default is False.
   * @param resource resource or {@code null} for none
   */
  public EventAttendee setResource(java.lang.Boolean resource) {
    this.resource = resource;
    return this;
  }

  /**
   * The attendee's response status. Possible values are: - "needsAction" - The attendee has not
   * responded to the invitation.  - "declined" - The attendee has declined the invitation.  -
   * "tentative" - The attendee has tentatively accepted the invitation.  - "accepted" - The
   * attendee has accepted the invitation.
   * @return value or {@code null} for none
   */
  public java.lang.String getResponseStatus() {
    return responseStatus;
  }

  /**
   * The attendee's response status. Possible values are: - "needsAction" - The attendee has not
   * responded to the invitation.  - "declined" - The attendee has declined the invitation.  -
   * "tentative" - The attendee has tentatively accepted the invitation.  - "accepted" - The
   * attendee has accepted the invitation.
   * @param responseStatus responseStatus or {@code null} for none
   */
  public EventAttendee setResponseStatus(java.lang.String responseStatus) {
    this.responseStatus = responseStatus;
    return this;
  }

  /**
   * Whether this entry represents the calendar on which this copy of the event appears. Read-only.
   * The default is False.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getSelf() {
    return self;
  }

  /**
   * Whether this entry represents the calendar on which this copy of the event appears. Read-only.
   * The default is False.
   * @param self self or {@code null} for none
   */
  public EventAttendee setSelf(java.lang.Boolean self) {
    this.self = self;
    return this;
  }

  @Override
  public EventAttendee set(String fieldName, Object value) {
    return (EventAttendee) super.set(fieldName, value);
  }

  @Override
  public EventAttendee clone() {
    return (EventAttendee) super.clone();
  }

}
