/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for FreeBusyCalendar.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FreeBusyCalendar extends com.google.api.client.json.GenericJson {

  /**
   * List of time ranges during which this calendar should be regarded as busy.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<TimePeriod> busy;

  static {
    // hack to force ProGuard to consider TimePeriod used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(TimePeriod.class);
  }

  /**
   * Optional error(s) (if computation for the calendar failed).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Error> errors;

  static {
    // hack to force ProGuard to consider Error used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Error.class);
  }

  /**
   * List of time ranges during which this calendar should be regarded as busy.
   * @return value or {@code null} for none
   */
  public java.util.List<TimePeriod> getBusy() {
    return busy;
  }

  /**
   * List of time ranges during which this calendar should be regarded as busy.
   * @param busy busy or {@code null} for none
   */
  public FreeBusyCalendar setBusy(java.util.List<TimePeriod> busy) {
    this.busy = busy;
    return this;
  }

  /**
   * Optional error(s) (if computation for the calendar failed).
   * @return value or {@code null} for none
   */
  public java.util.List<Error> getErrors() {
    return errors;
  }

  /**
   * Optional error(s) (if computation for the calendar failed).
   * @param errors errors or {@code null} for none
   */
  public FreeBusyCalendar setErrors(java.util.List<Error> errors) {
    this.errors = errors;
    return this;
  }

  @Override
  public FreeBusyCalendar set(String fieldName, Object value) {
    return (FreeBusyCalendar) super.set(fieldName, value);
  }

  @Override
  public FreeBusyCalendar clone() {
    return (FreeBusyCalendar) super.clone();
  }

}
