/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:19:26 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.calendar.model;

/**
 * Model definition for TimePeriod.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Calendar API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TimePeriod extends com.google.api.client.json.GenericJson {

  /**
   * The (exclusive) end of the time period.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime end;

  /**
   * The (inclusive) start of the time period.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime start;

  /**
   * The (exclusive) end of the time period.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEnd() {
    return end;
  }

  /**
   * The (exclusive) end of the time period.
   * @param end end or {@code null} for none
   */
  public TimePeriod setEnd(com.google.api.client.util.DateTime end) {
    this.end = end;
    return this;
  }

  /**
   * The (inclusive) start of the time period.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getStart() {
    return start;
  }

  /**
   * The (inclusive) start of the time period.
   * @param start start or {@code null} for none
   */
  public TimePeriod setStart(com.google.api.client.util.DateTime start) {
    this.start = start;
    return this;
  }

  @Override
  public TimePeriod set(String fieldName, Object value) {
    return (TimePeriod) super.set(fieldName, value);
  }

  @Override
  public TimePeriod clone() {
    return (TimePeriod) super.clone();
  }

}
